<?php
class Audentio_SponsorDirectory_ControllerPublic_Sponsor extends XenForo_ControllerPublic_Abstract
{
	protected function _preDispatch($action)
	{
		$xenOptions = XenForo_Application::get('options')->getOptions();
		if (!$xenOptions['adsponsordirectory_enableSponsorPage'])
		{
			throw $this->responseException($this->responseReroute('XenForo_ControllerPublic_Error', 'ErrorNotFound'));
		}
	}

	public function actionIndex()
	{
		$visitor = XenForo_Visitor::getInstance();
		if (!$visitor->hasPermission('adsponsordirectory', 'canViewSponsorPage'))
		{
			return $this->responseReroute('XenForo_ControllerPublic_Error', 'noPermission');
		}
		$sponsorModel = $this->_getSponsorModel();
		$sponsors = $sponsorModel->getPageSponsors();

		foreach ($sponsors as &$sponsor)
		{
			$sponsor['image'] = XenForo_Application::$externalDataUrl . "/sponsor/".$sponsor['uploaded_image_name'];
		}

		$viewParams = array(
			'sponsors'	=> $sponsors,
		);
		return $this->responseView('Audentio_SponsorDirectory_ViewPublic_Sponsor_Page', 'adsponsordirectory_sponsor_page', $viewParams);
	}

	protected function _getSponsorModel()
	{
		return $this->getModelFromCache('Audentio_SponsorDirectory_Model_Sponsor');
	}
}