<?php
class Audentio_SponsorDirectory_DataWriter_Sponsor extends XenForo_DataWriter
{
	protected function _getFields()
	{
		return array(
			'adsponsordirectory_sponsor'	=> array(
				'sponsor_id'				=> array('type' => self::TYPE_UINT,  'autoIncrement' => true),
				'title'                     => array('type' => self::TYPE_STRING,  'maxLength' => 50, 'required' => true,
					'requiredError'			=> 'please_enter_valid_title'
				),
				'description'				=> array('type' => self::TYPE_STRING,  'maxLength' => 255, 'default' => ''),
				'active'					=> array('type' => self::TYPE_BOOLEAN, 'default' => 1),
				'url'						=> array('type' => self::TYPE_STRING,  'maxLength' => 255, 'required' => true),
				'use_uploaded_file'			=> array('type' => self::TYPE_BOOLEAN, 'default' => 0),
				'uploaded_image_name'		=> array('type' => self::TYPE_STRING,  'maxLength' => 255, 'default' => ''),
				'image_url'					=> array('type' => self::TYPE_STRING,  'maxLength' => 255, 'default' => ''),
				'display_in_bar'			=> array('type' => self::TYPE_BOOLEAN, 'default' => 1),
				'display_on_page'			=> array('type' => self::TYPE_BOOLEAN, 'default' => 1),
				'width'						=> array('type' => self::TYPE_UINT, 'default' => 0),
				'height'					=> array('type' => self::TYPE_UINT, 'default' => 0),
				'display_order'				=> array('type' => self::TYPE_UINT, 'default' => 10),
			)
		);
	}

	protected function _getExistingData($data)
	{
		if (!$sponsorId = $this->_getExistingPrimaryKey($data, 'sponsor_id'))
		{
			return false;
		}

		return array('adsponsordirectory_sponsor' => $this->_getSponsorModel()->getSponsorById($sponsorId));
	}

	protected function _getUpdateCondition($tableName)
	{
		return 'sponsor_id = ' . $this->_db->quote($this->getExisting('sponsor_id'));
	}

	protected function _getSponsorModel()
	{
		return $this->getModelFromCache('Audentio_SponsorDirectory_Model_Sponsor');
	}
}