<?php
class Audentio_SponsorDirectory_Listener_CodeEvent
{
	public static function containerPublicParams(array &$params, XenForo_Dependencies_Abstract $dependencies)
	{
		if (!isset($params['sponsorBar']))
		{
			$sponsors = array();
			$visitor = XenForo_Visitor::getInstance();
			if ($visitor->hasPermission('adsponsordirectory', 'canViewSponsorBar'))
			{
				$sponsors = XenForo_Model::create('Audentio_SponsorDirectory_Model_Sponsor')->getBarSponsors();

				foreach ($sponsors as &$sponsor)
				{
					if (!$sponsor['use_uploaded_file'])
					{
						$sponsor['image'] = $sponsor['image_url'];
						continue;
					}
					$sponsor['image'] = XenForo_Application::$externalDataUrl . "/sponsor/".$sponsor['uploaded_image_name'];
				}
			}
			$params['sponsorBar'] = $sponsors;
		}
	}

	public static function templateHook($hookName, &$contents, array $hookParams, XenForo_Template_Abstract $template)
	{
		$xenOptions = XenForo_Application::getOptions();
		$visitor = XenForo_Visitor::getInstance();
		if ($xenOptions->adsponsordirectory_sponsorBarLocation == 100 && $hookName == $xenOptions->adsponsordirectory_customHookLocation)
		{
			$viewParams = $template->getParams();
			$contents .= $template->create('adsponsordirectory_sponsor_bar', $viewParams)->render();
		}
	}
}